/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
	"fmt"
)

// OperationRequestLeftJoin - struct for OperationRequestLeftJoin
type OperationRequestLeftJoin struct {
	LeftJoinRequest *LeftJoinRequest
}

// LeftJoinRequestAsOperationRequestLeftJoin is a convenience function that returns LeftJoinRequest wrapped in OperationRequestLeftJoin
func LeftJoinRequestAsOperationRequestLeftJoin(v *LeftJoinRequest) OperationRequestLeftJoin {
	return OperationRequestLeftJoin{
		LeftJoinRequest: v,
	}
}

// Unmarshal JSON data into one of the pointers in the struct
func (dst *OperationRequestLeftJoin) UnmarshalJSON(data []byte) error {
	var err error
	// this object is nullable so check if the payload is null or empty string
	if string(data) == "" || string(data) == "{}" {
		return nil
	}

	match := 0
	// try to unmarshal data into LeftJoinRequest
	err = newStrictDecoder(data).Decode(&dst.LeftJoinRequest)
	if err == nil {
		jsonLeftJoinRequest, _ := json.Marshal(dst.LeftJoinRequest)
		if string(jsonLeftJoinRequest) == "{}" { // empty struct
			dst.LeftJoinRequest = nil
		} else {
			match++
		}
	} else {
		dst.LeftJoinRequest = nil
	}

	if match > 1 { // more than 1 match
		// reset to nil
		dst.LeftJoinRequest = nil

		return fmt.Errorf("data matches more than one schema in oneOf(OperationRequestLeftJoin)")
	} else if match == 1 {
		return nil // exactly one match
	} else { // no match
		return fmt.Errorf("data failed to match schemas in oneOf(OperationRequestLeftJoin)")
	}
}

// Marshal data from the first non-nil pointers in the struct to JSON
func (src OperationRequestLeftJoin) MarshalJSON() ([]byte, error) {
	if src.LeftJoinRequest != nil {
		return json.Marshal(&src.LeftJoinRequest)
	}

	return nil, nil // no data in oneOf schemas
}

// Get the actual instance
func (obj *OperationRequestLeftJoin) GetActualInstance() interface{} {
	if obj == nil {
		return nil
	}
	if obj.LeftJoinRequest != nil {
		return obj.LeftJoinRequest
	}

	// all schemas are nil
	return nil
}

type NullableOperationRequestLeftJoin struct {
	value *OperationRequestLeftJoin
	isSet bool
}

func (v NullableOperationRequestLeftJoin) Get() *OperationRequestLeftJoin {
	return v.value
}

func (v *NullableOperationRequestLeftJoin) Set(val *OperationRequestLeftJoin) {
	v.value = val
	v.isSet = true
}

func (v NullableOperationRequestLeftJoin) IsSet() bool {
	return v.isSet
}

func (v *NullableOperationRequestLeftJoin) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableOperationRequestLeftJoin(val *OperationRequestLeftJoin) *NullableOperationRequestLeftJoin {
	return &NullableOperationRequestLeftJoin{value: val, isSet: true}
}

func (v NullableOperationRequestLeftJoin) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableOperationRequestLeftJoin) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
